MergeCFLAGS()
GetCompilers()

include(ExternalProject)

IF (MSVC)
	SET (CUSTOM_CMAKE_ARGS -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY:PATH=${THIRD_PARTY_DIR}/libs/gmock
		-DCMAKE_LIBRARY_OUTPUT_DIRECTORY:PATH=${THIRD_PARTY_DIR}/libs/gmock
		-DCMAKE_CXX_FLAGS:STRING=${CMAKE_CXX_FLAGS}${CMAKE_DEFINITIONS}
		-DCMAKE_CXX_FLAGS_RELEASE:STRING=${CMAKE_CXX_FLAGS_RELEASE}
		-DCMAKE_CXX_FLAGS_DISTRIBUTION:STRING=${CMAKE_CXX_FLAGS_DISTRIBUTION}
		-DCMAKE_CXX_FLAGS_DEBUG:STRING=${CMAKE_CXX_FLAGS_DEBUG}
		-DCMAKE_C_COMPILER:STRING=${C_COMPILER}
		-DCMAKE_CXX_COMPILER:STRING=${CXX_COMPILER}
	)
ELSE ()
	SET(MERGED_CXX_FLAGS "${MERGED_CXX_FLAGS} -fPIC")
	SET (CUSTOM_CMAKE_ARGS -DCMAKE_ARCHIVE_OUTPUT_DIRECTORY:PATH=${THIRD_PARTY_DIR}/libs/gmock
		-DCMAKE_LIBRARY_OUTPUT_DIRECTORY:PATH=${THIRD_PARTY_DIR}/libs/gmock
		-DCMAKE_CXX_FLAGS:STRING=${MERGED_CXX_FLAGS}${CMAKE_DEFINITIONS}
		-DCMAKE_C_COMPILER:STRING=${C_COMPILER}
		-DCMAKE_CXX_COMPILER:STRING=${CXX_COMPILER}
	)
ENDIF()

IF(EXISTS /usr/src/googletest)
	ExternalProject_Add(
		GoogleMock
		DOWNLOAD_COMMAND ""
		SOURCE_DIR /usr/src/googletest
		PREFIX ${CMAKE_BINARY_DIR}/GoogleMock
		INSTALL_COMMAND ""
		CMAKE_ARGS ${CUSTOM_CMAKE_ARGS}
	)
ELSE()
	ExternalProject_Add(
		GoogleMock
		URL https://github.com/google/googletest/archive/release-1.8.0.tar.gz
		URL_MD5 16877098823401d1bf2ed7891d7dce36
		TIMEOUT 10
		PREFIX ${CMAKE_BINARY_DIR}/GoogleMock
		DOWNLOAD_DIR ${THIRD_PARTY_DIR}/GoogleMock
		INSTALL_COMMAND ""
		CMAKE_ARGS ${CUSTOM_CMAKE_ARGS}
	)
ENDIF()

UNSET(C_COMPILER)
UNSET(CXX_COMPILER)